                                                                   '************* Konfiguracja uC *****************
'***********************************************
$regfile = "m8def.dat"
$crystal = 16000000

Config Portb = &B11111111 : Portb = &B11111111
Config Portc = &B00000011 : Portc = &BXXXXXX00
Config Portd = &B11111100 : Portd = &B11111111

Config Lcdpin = Pin , Db4 = Portb.2 , Db5 = Portb.3 , Db6 = Portb.4 , Db7 = Portb.5 , E = Portb.1 , Rs = Portb.0
Config Lcd = 20 * 4
Cls
Cursor Off Noblink

G1 Alias Portd.4
G2 Alias Portd.7
G3 Alias Portd.6
G4 Alias Portd.5
G5 Alias Portd.2
G6 Alias Portd.3
Over_pos Alias Portc.0
Over_neg Alias Portc.1
Sw1 Alias Pind.0
Sw2 Alias Pind.1


Config Timer0 = Timer , Prescale = 1024
Enable Timer0 : On Timer0 Pt0

Config Adc = Single , Prescaler = Auto , Reference = Aref
Start Adc

Enable Interrupts
'**************************************************
Dim X(4) As Word
Dim Mx(4) As Single
Dim Y(4) As Single
Dim N As Byte
Dim Xx As Word
Dim Zmierzono As Bit

Dim Mod_1 As Byte
Dim Mod_2 As Byte

Dim Curr_pos_z As Byte                                      '0...3
Dim Curr_neg_z As Byte                                      '0...3
Dim Volt_pos_z As Byte                                      '0...1
Dim Volt_neg_z As Byte                                      '0...1

Dim Curr_pos(4) As Single
Dim Curr_neg(4) As Single
Dim Volt_pos(2) As Single
Dim Volt_neg(2) As Single
Dim N_max As Byte

Dim S As String * 10
Dim I As Byte
Dim F_16ms As Bit
Dim Sw_licz(2) As Byte

'**************************************************
N_max = 50
Curr_pos(4) = 4.6497252747
Curr_pos(3) = 3.6080586081
Curr_pos(2) = 1.3163919414
Curr_pos(1) = 0.2747252747

Curr_neg(4) = 4.6497252747
Curr_neg(3) = 3.6080586081
Curr_neg(2) = 1.3163919414
Curr_neg(1) = 0.2747252747

Volt_pos(1) = 0.0112500000
Volt_pos(2) = 0.0429242081

Volt_neg(1) = 0.0112500000
Volt_neg(2) = 0.0429242081
'**************************************************

Curr_pos_z = 0
Curr_neg_z = 0
Volt_pos_z = 0
Volt_neg_z = 0
Gosub Zakresy

Lcd "Miernik Panelowy"
Lowerline
Lcd "   by mirley"
Waitms 250
Cls

Do
'************
If F_16ms = 1 Then
  F_16ms = 0

  If Sw1 = 0 Then
    Incr Sw_licz(1)
    If Sw_licz(1) = 6 Then
      Incr Mod_1
      If Mod_1 = 3 Then Mod_1 = 0
    End If
  Else
    Sw_licz(1) = 0
  End If

  If Sw2 = 0 Then
    Incr Sw_licz(2)
    If Sw_licz(2) = 6 Then
      Incr Mod_2
      If Mod_2 = 3 Then Mod_2 = 0
    End If
  Else
    Sw_licz(2) = 0
  End If

End If


If Zmierzono = 1 Then
  Zmierzono = 0
'********************************************************************
  For I = 1 To 4                                            '4 nie liczymy bo nie potrzebne
    Mx(i) = 1010 * Curr_pos(i)                              'wyliczanie bezpiecznego maxa dla kadego z zakresow
  Next I
  Y(1) = Y(1) * Curr_pos(curr_pos_z + 1)
  If Y(1) < Mx(3) Then
    Over_pos = 0
    Curr_pos_z = 2
    If Y(1) < Mx(2) Then
      Curr_pos_z = 1
      If Y(1) < Mx(1) Then Curr_pos_z = 0
    End If
  Else
    Curr_pos_z = 3
    If Y(1) > Mx(4) Then Over_pos = 1
  End If
  '**********************************
  Mx(1) = 1010 * Volt_pos(1)                                'wyliczanie bezpiecznego maxa dla kadego z zakresow
  Y(2) = Y(2) * Volt_pos(volt_pos_z + 1)
  If Y(2) < Mx(1) Then Volt_pos_z = 0 Else Volt_pos_z = 1
  '**********************************
  For I = 1 To 4                                            '4 nie liczymy bo nie potrzebne
    Mx(i) = 1010 * Curr_neg(i)                              'wyliczanie bezpiecznego maxa dla kadego z zakresow
  Next I
  Y(4) = Y(4) * Curr_neg(curr_neg_z + 1)
  If Y(4) < Mx(3) Then
    Over_neg = 0
    Curr_neg_z = 2
    If Y(4) < Mx(2) Then
      Curr_neg_z = 1
      If Y(4) < Mx(1) Then Curr_neg_z = 0
    End If
  Else
    Curr_neg_z = 3
    If Y(4) > Mx(4) Then Over_neg = 1
  End If
  '**********************************
  Mx(1) = 1010 * Volt_neg(1)                                'wyliczanie bezpiecznego maxa dla kadego z zakresow
  Y(3) = Y(3) * Volt_neg(volt_neg_z + 1)
  If Y(3) < Mx(1) Then Volt_neg_z = 0 Else Volt_neg_z = 1
  '**********************************

  Gosub Zakresy
  '**********************************
  Locate 1 , 1
  Lcd "+"
  If Y(2) < 10.0 Then Lcd " "
  S = Fusing(y(2) , "#.##")
  Lcd S ; "V "
  '**********************************
  If Mod_1 = 0 Then                                         'jesli pokazuje prad
    If Y(1) < 260 Then
      If Y(1) < 100 Then Lcd " "
      If Y(1) < 10 Then Lcd " "
      S = Fusing(y(1) , "#.##")
      Lcd S ; "mA"
    Else
      Y(1) = Y(1) / 1000
      S = Fusing(y(1) , "#.####")
      Lcd " " ; S ; "A"
    End If
  Elseif Mod_1 = 1 Then
    Y(1) = Y(1) * Y(2)                                      'liczenie mocy
    If Y(1) < 1000 Then
      If Y(1) < 100 Then Lcd " "
      If Y(1) < 10 Then Lcd " "
      S = Fusing(y(1) , "#.##")
      Lcd S ; "mW"
    Else
      Y(1) = Y(1) / 1000
      If Y(1) < 10 Then Lcd " "
      S = Fusing(y(1) , "#.####")
      Lcd S ; "W"
    End If
  Else                                                      'liczenie rezystancji
    Y(1) = Y(2) / Y(1)
    Y(1) = Y(1) * 1000
    If Y(1) < 100 Then Lcd " "
    If Y(1) < 10 Then Lcd " "
    S = Fusing(y(1) , "#.##")
    Lcd " " ; S ; "R"
  End If
  '**********************************
  Locate 2 , 1
  Lcd "-"
  If Y(3) < 10.0 Then Lcd " "
  S = Fusing(y(3) , "#.##")
  Lcd S ; "V "
  '**********************************
  If Mod_2 = 0 Then                                         'jesli pokazuje prad
    If Y(4) < 260 Then
      If Y(4) < 100 Then Lcd " "
      If Y(4) < 10 Then Lcd " "
      S = Fusing(y(4) , "#.##")
      Lcd S ; "mA"
    Else
      Y(4) = Y(4) / 1000
      S = Fusing(y(4) , "#.####")
      Lcd " " ; S ; "A"
    End If
  Elseif Mod_2 = 1 Then
    Y(4) = Y(3) * Y(4)                                      'liczenie mocy
    If Y(4) < 1000 Then
      If Y(4) < 100 Then Lcd " "
      If Y(4) < 10 Then Lcd " "
      S = Fusing(y(4) , "#.##")
      Lcd S ; "mW"
    Else
      Y(4) = Y(4) / 1000
      If Y(4) < 10 Then Lcd " "
      S = Fusing(y(4) , "#.####")
      Lcd S ; "W"
    End If
  Else
    Y(4) = Y(3) / Y(4)
    Y(4) = Y(4) * 1000
    If Y(4) < 100 Then Lcd " "
    If Y(4) < 10 Then Lcd " "
    S = Fusing(y(4) , "#.##")
    Lcd " " ; S ; "R"
  End If
  '**********************************
End If


'************
Loop
End

'**************************************************
Pt0:
  Timer0 = 6
  Set F_16ms
  Incr N
  For I = 2 To 5
    Xx = Getadc(i)
    X(i -1) = X(i -1) + Xx
  Next I

  If N >= N_max Then
    N = 0
    For I = 1 To 4
      Y(i) = X(i) / N_max
      X(i) = 0
    Next I
    Set Zmierzono
  End If
Return

'**************************************************
Zakresy:
 G1 = Curr_pos_z.0
 G2 = Curr_pos_z.1
 G4 = Curr_neg_z.0
 G3 = Curr_neg_z.1
 G5 = Volt_pos_z
 G6 = Volt_neg_z
Return
'**************************************************